﻿// // ******************************************************************
// //       /\ /|       @File         DecodeParams.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-5-6
// //      /  \\        @Modified      2024-5-13
// //    *(__\_\
// // ******************************************************************

#pragma once

#include "EdgePulse.h"
#include "BaseEnums/ProtocolEnums.h"

namespace Protocol
{
    //顶级父类 各协议自身内部实现细节
    //包含协议传入参数 和 协议传入数据
    //到此类的数据类型 即位多个边沿脉宽序列
    struct DecodeParams
    {
    public:
        SerialProtocolType ProtocolType;

        //自动时钟恢复
        uint8_t AutomaticClockRecovery;

        //子协议 实现扩展
        void* ProtocolParamsPtr;

        DecodeParams();

        DecodeParams(const DecodeParams& decodeParams);

        // virtual ~DecodeParams();
        //
        // virtual void SomeVirtual()
        // {
        // }
    };
}
