﻿// // ******************************************************************
// //       /\ /|       @File         UsbDecodeResult.h
// //       \ V/        @Brief
// //       | "")       @Author        lijinwen, ghz005@uni-trend.com.cn
// //       /  |        @Creation      2024-3-14
// //      /  \\        @Modified      2024-5-13
// //    *(__\_\
// // ******************************************************************

#pragma once
#include <utility>

#include "ProtocolUsbEnums.h"
#include "../DecodeResult.h"
#include "UsbPacket.h"
#include "UsbDecodeEvent.h"

namespace Protocol::ProtocolUsb
{
    class UsbDecodeResultUnit : DecodeResultUnit
    {
    public:
        UsbPacket GetUsbPacket() { return UsbPacket; }

        UsbDecodeResultUnit(UsbPacket packet)
        {
            UsbPacket = std::move(packet);
        }

    private:
        UsbPacket UsbPacket;
    };

    struct UsbDecodeResult //: DecodeResult
    {
        // SerialProtocolType GetProtocolType() override
        // {
        //     return SerialProtocolType::USB;
        // }

        std::vector<UsbDecodeResultUnit> DecodeResultUnits;
        std::vector<UsbDecodeEvent> DecodeEventUnits;
        void Add(const UsbDecodeResultUnit* unit);
        void ClearData();
    };
}
